using System;
using System.Collections.Generic;
using System.Text;

namespace AsynchCalcPi2005
{
    class AsyncCalcPiForm4_Thread3_Async : AsyncCalcPiForm3_Thread2_Sync
    {
        public AsyncCalcPiForm4_Thread3_Async()
            : base()
        {

        }

        override protected void buttonCalc_Click(object sender, EventArgs e)
        {
            this.calcToolStripProgressBar.Value = 0;
            this.calcToolStripProgressBar.Visible = true;
            this.calcToolStripStatusLabel.Text = "Calculating...";

            CalcPiDelegate calcPi = new CalcPiDelegate(CalcPi);
            calcPi.BeginInvoke(
                (int)this.decimalPlacesNumericUpDown.Value,
                EndCalcPi,
                calcPi);
        }

        virtual protected void EndCalcPi(IAsyncResult result)
        {
            try
            {
                CalcPiDelegate calcPi = (CalcPiDelegate)result.AsyncState;
                calcPi.EndInvoke(result);
            }
            catch (Exception ex)
            {
                //Error!!!
                ShowProgress(ex.Message, 0, 0);
            }
        }
    }
}
